commit 7de0cc90a3bd7145a5160729fddc72a9aa46d330
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Thu Feb 21 18:04:04 2019 +0100

    All preprocessor directives without arguments (e.g. #endif) are now followed by a comment, indicating where it belongs to (e.g. the preceding #if).

diff --git a/modules/NUCLEO-F103RB/module.h b/modules/NUCLEO-F103RB/module.h
index 7a5bdf8..15cb346 100644
--- a/modules/NUCLEO-F103RB/module.h
+++ b/modules/NUCLEO-F103RB/module.h
@@ -36,19 +36,19 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 /*===========================================================================*/
 
-#ifdef AMIROLLD_CFG_DW1000
+#if defined(AMIROLLD_CFG_DW1000)
 
-#ifdef __cplusplus
+#if defined(__cplusplus)
 extern "C" {
-#endif
+#endif /* defined(__cplusplus) */
 
 void dw1000_spi_init(void);
 
-#ifdef __cplusplus
+#if defined(__cplusplus)
 }
-#endif
+#endif /* defined(__cplusplus) */
 
-#endif /* AMIROLLD_CFG_DW1000 */
+#endif /* defined(AMIROLLD_CFG_DW1000) */
 
 
 /** @} */
@@ -76,7 +76,7 @@ extern SerialConfig moduleHalProgIfConfig;
 #define MODULE_HAL_RTC                          RTCD1
 
 
-#ifdef AMIROLLD_CFG_DW1000
+#if defined(AMIROLLD_CFG_DW1000)
 
 /**
  * @brief   SPI interface driver for the motion sensors (gyroscope and accelerometer).
@@ -94,7 +94,7 @@ extern SPIConfig moduleHalSpiUwbHsConfig;
  */
 extern SPIConfig moduleHalSpiUwbLsConfig;
 
-#endif /* AMIROLLD_CFG_DW1000 */
+#endif /* defined(AMIROLLD_CFG_DW1000) */
 
 /** @} */
 
@@ -111,7 +111,7 @@ extern SPIConfig moduleHalSpiUwbLsConfig;
  */
 extern ROMCONST apalControlGpio_t moduleGpioLed;
 
-#ifdef AMIROLLD_CFG_DW1000
+#if defined(AMIROLLD_CFG_DW1000)
 /**
  * @brief   DW1000 reset output signal
  * @note    the reset pin should be drived as low by MCU to activate.
@@ -130,7 +130,7 @@ extern ROMCONST apalControlGpio_t moduleGpioDw1000Irqn;
  */
 extern ROMCONST apalControlGpio_t moduleGpioSpiChipSelect ;
 
-#endif /* AMIROLLD_CFG_DW1000 */
+#endif /* defined(AMIROLLD_CFG_DW1000) */
 
 /**
  * @brief   User button input signal.
@@ -162,7 +162,7 @@ extern ROMCONST apalControlGpio_t moduleGpioUserButton;
  * @brief   Shell prompt text.
  */
 extern ROMCONST char* moduleShellPrompt;
-#endif
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
 
 
 /**
@@ -175,15 +175,15 @@ extern ROMCONST char* moduleShellPrompt;
   palEnablePadEvent(moduleGpioUserButton.gpio->port, moduleGpioUserButton.gpio->pad, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));   \
   MODULE_INIT_INTERRUPTS_DW1000();                                            \
 }
-#ifdef AMIROLLD_CFG_DW1000
+#if defined(AMIROLLD_CFG_DW1000)
   #define MODULE_INIT_INTERRUPTS_DW1000() {                                   \
     palSetPadCallback(moduleGpioDw1000Irqn.gpio->port, moduleGpioDw1000Irqn.gpio->pad, _intCallback, &moduleGpioDw1000Irqn.gpio->pad);  \
     palEnablePadEvent(moduleGpioDw1000Irqn.gpio->port, moduleGpioDw1000Irqn.gpio->pad, APAL2CH_EDGE(moduleGpioDw1000Irqn.meta.edge));   \
   }
-#else
-  #define MODULE_INIT_INTERRUPTS_DW1000() {                                  \
+#else /* defined(AMIROLLD_CFG_DW1000) */
+  #define MODULE_INIT_INTERRUPTS_DW1000() {                                   \
   }
-#endif /* AMIROLLD_CFG_DW1000 */
+#endif /* defined(AMIROLLD_CFG_DW1000) */
 
 
 /**
@@ -193,14 +193,14 @@ extern ROMCONST char* moduleShellPrompt;
   /* add unit-test shell commands */                                          \
   MODULE_INIT_TESTS_DW1000();                                                 \
 }
-#ifdef AMIROLLD_CFG_DW1000
+#if defined(AMIROLLD_CFG_DW1000)
   #define MODULE_INIT_TESTS_DW1000() {                                        \
     aosShellAddCommand(&aos.shell, &moduleUtAlldDw1000.shellcmd);             \
   }
-#else
-  #define MODULE_INIT_TESTS_DW1000() {                                         \
+#else /* defined(AMIROLLD_CFG_DW1000) */
+  #define MODULE_INIT_TESTS_DW1000() {                                        \
   }
-#endif /* AMIROLLD_CFG_DW1000 */
+#endif /* defined(AMIROLLD_CFG_DW1000) */
 
 
 /**
@@ -211,16 +211,16 @@ extern ROMCONST char* moduleShellPrompt;
   sdStart(&MODULE_HAL_PROGIF, &moduleHalProgIfConfig);                        \
   MODULE_INIT_PERIPHERY_COMM_DW1000();                                        \
 }
-#ifdef AMIROLLD_CFG_DW1000
+#if defined(AMIROLLD_CFG_DW1000)
   #define MODULE_INIT_PERIPHERY_COMM_DW1000() {                               \
     /* SPI init */                                                            \
     dw1000_spi_init();                                                        \
     spiStart(&MODULE_HAL_SPI_UWB, &moduleHalSpiUwbLsConfig);                  \
   }
-#else
+#else /* defined(AMIROLLD_CFG_DW1000) */
   #define MODULE_INIT_PERIPHERY_COMM_DW1000() {                               \
   }
-#endif /* AMIROLLD_CFG_DW1000 */
+#endif /* defined(AMIROLLD_CFG_DW1000) */
 
 
 /**
@@ -229,20 +229,20 @@ extern ROMCONST char* moduleShellPrompt;
 #define MODULE_SHUTDOWN_PERIPHERY_COMM() {                                    \
   MODULE_SHUTDOWN_PERIPHERY_COMM_DW1000();                                    \
 }
-#ifdef AMIROLLD_CFG_DW1000
+#if defined(AMIROLLD_CFG_DW1000)
 #define MODULE_SHUTDOWN_PERIPHERY_COMM_DW1000() {                             \
   /* SPI */                                                                   \
   spiStop(&MODULE_HAL_SPI_UWB);                                               \
 }
-#else
+#else /* defined(AMIROLLD_CFG_DW1000) */
   #define MODULE_SHUTDOWN_PERIPHERY_COMM_DW1000() {                           \
   }
-#endif /* AMIROLLD_CFG_DW1000 */
+#endif /* defined(AMIROLLD_CFG_DW1000) */
 
 /**
  * @brief   HOOK to call process_deca_irq() func when the dw1000 interrupt pin is activated.
  */
-#define MODULE_MAIN_LOOP_IO_EVENT(eventflags) {		                          \
+#define MODULE_MAIN_LOOP_IO_EVENT(eventflags) {	                              \
   if (eventflags & MODULE_OS_IOEVENTFLAGS_USERBUTTON) {                       \
     apalControlGpioState_t buttonstate;                                       \
     apalControlGpioGet(&moduleGpioUserButton, &buttonstate);                  \
@@ -250,17 +250,17 @@ extern ROMCONST char* moduleShellPrompt;
   }                                                                           \
   MODULE_MAIN_LOOP_IO_EVENT_DW1000();                                         \
 }
-#ifdef AMIROLLD_CFG_DW1000
+#if defined(AMIROLLD_CFG_DW1000)
   #define MODULE_MAIN_LOOP_IO_EVENT_DW1000() {                                \
-    if(eventflags & MODULE_OS_IOEVENTFLAGS_DW1000_IRQn) {		              \
+    if(eventflags & MODULE_OS_IOEVENTFLAGS_DW1000_IRQn) {                     \
       /*apalGpioToggle(moduleGpioLedGreen.gpio); // just for debug  */        \
       process_deca_irq();                                                     \
-    }	                                                                      \
+    }                                                                         \
   }
-#else
+#else /* defined(AMIROLLD_CFG_DW1000) */
   #define MODULE_MAIN_LOOP_IO_EVENT_DW1000() {                                \
   }
-#endif  /* AMIROLLD_CFG_DW1000 */
+#endif /* defined(AMIROLLD_CFG_DW1000) */
 
 /** @} */
 
@@ -279,12 +279,12 @@ extern ROMCONST char* moduleShellPrompt;
  * @{
  */
 /*===========================================================================*/
-#ifdef AMIROLLD_CFG_DW1000
+#if defined(AMIROLLD_CFG_DW1000)
 #include <alld_DW1000.h>
 
 extern DW1000Driver moduleLldDw1000;
 
-#endif /* AMIROLLD_CFG_DW1000 */
+#endif /* defined(AMIROLLD_CFG_DW1000) */
 
 /** @} */
 
@@ -297,7 +297,7 @@ extern DW1000Driver moduleLldDw1000;
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
 
 #if defined(AMIROLLD_CFG_DW1000) && (AMIROLLD_CFG_DW1000 == 1)
-#include<ut_alld_dw1000_v1.h>
+#include <ut_alld_dw1000_v1.h>
 
 /**
  * @brief   DW1000 unit test object.
@@ -306,7 +306,7 @@ extern aos_unittest_t moduleUtAlldDw1000;
 
 #endif /* defined(AMIROLLD_CFG_DW1000) && (AMIROLLD_CFG_DW1000 == 1) */
 
-#endif /* AMIROOS_CFG_TESTS_ENABLE == true */
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 
 /** @} */
 