commit 7de0cc90a3bd7145a5160729fddc72a9aa46d330
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Thu Feb 21 18:04:04 2019 +0100

    All preprocessor directives without arguments (e.g. #endif) are now followed by a comment, indicating where it belongs to (e.g. the preceding #if).

diff --git a/modules/STM32F407G-DISC1/aosconf.h b/modules/STM32F407G-DISC1/aosconf.h
index a61adfe..f2ab8d2 100644
--- a/modules/STM32F407G-DISC1/aosconf.h
+++ b/modules/STM32F407G-DISC1/aosconf.h
@@ -42,7 +42,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #if defined(AMIRO_APPS) && (AMIRO_APPS == true)
   #include <osconf.h>
-#endif
+#endif /* defined(AMIRO_APPS) && (AMIRO_APPS == true) */
 
 /*===========================================================================*/
 /**
@@ -56,9 +56,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #if !defined(OS_CFG_DBG)
   #define AMIROOS_CFG_DBG                       true
-#else
+#else /* !defined(OS_CFG_DBG) */
   #define AMIROOS_CFG_DBG                       OS_CFG_DBG
-#endif
+#endif /* !defined(OS_CFG_DBG) */
 
 /**
  * @brief   Flag to enable/disable unit tests.
@@ -66,18 +66,18 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #if !defined(OS_CFG_TESTS_ENABLE)
   #define AMIROOS_CFG_TESTS_ENABLE              true
-#else
+#else /* !defined(OS_CFG_TESTS_ENABLE) */
   #define AMIROOS_CFG_TESTS_ENABLE              OS_CFG_TESTS_ENABLE
-#endif
+#endif /* !defined(OS_CFG_TESTS_ENABLE) */
 
 /**
  * @brief   Flag to enable/disable profiling API and logic.
  */
 #if !defined(OS_CFG_PROFILE)
   #define AMIROOS_CFG_PROFILE                   true
-#else
+#else /* !defined(OS_CFG_PROFILE) */
   #define AMIROOS_CFG_PROFILE                   OS_CFG_PROFILE
-#endif
+#endif /* !defined(OS_CFG_PROFILE) */
 
 /**
  * @brief   Mask for the control thread to listen to certain IO events.
@@ -85,9 +85,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #if !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK)
   #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    MODULE_OS_IOEVENTFLAGS_USERBUTTON
-#else
+#else /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
   #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    OS_CFG_MAIN_LOOP_IOEVENT_MASK
-#endif
+#endif /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
 
 /**
  * @brief   Timeout value when waiting for events in the main loop in microseconds.
@@ -95,9 +95,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #if !defined(OS_CFG_MAIN_LOOP_TIMEOUT)
   #define AMIROOS_CFG_MAIN_LOOP_TIMEOUT         0
-#else
+#else /* !defined(OS_CFG_MAIN_LOOP_TIMEOUT) */
   #define AMIROOS_CFG_MAIN_LOOP_TIMEOUT         OS_CFG_MAIN_LOOP_TIMEOUT
-#endif
+#endif /* !defined(OS_CFG_MAIN_LOOP_TIMEOUT) */
 
 /** @} */
 
@@ -113,9 +113,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #if !defined(OS_CFG_SSSP_ENABLE)
   #define AMIROOS_CFG_SSSP_ENABLE               false
-#else
+#else /* !defined(OS_CFG_SSSP_ENABLE) */
   #define AMIROOS_CFG_SSSP_ENABLE               OS_CFG_SSSP_ENABLE
-#endif
+#endif /* !defined(OS_CFG_SSSP_ENABLE) */
 
 /**
  * @brief   Flag to set the module as SSSP master.
@@ -123,9 +123,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #if !defined(OS_CFG_SSSP_MASTER)
   #define AMIROOS_CFG_SSSP_MASTER               false
-#else
+#else /* !defined(OS_CFG_SSSP_MASTER) */
   #define AMIROOS_CFG_SSSP_MASTER               OS_CFG_SSSP_MASTER
-#endif
+#endif /* !defined(OS_CFG_SSSP_MASTER) */
 
 /**
  * @brief   Flag to set the module to be the first in the stack.
@@ -133,9 +133,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #if !defined(OS_CFG_SSSP_STACK_START)
   #define AMIROOS_CFG_SSSP_STACK_START          false
-#else
+#else /* !defined(OS_CFG_SSSP_STACK_START) */
   #define AMIROOS_CFG_SSSP_STACK_START          OS_CFG_SSSP_STACK_START
-#endif
+#endif /* !defined(OS_CFG_SSSP_STACK_START) */
 
 /**
  * @brief   Flag to set the module to be the last in the stack.
@@ -143,18 +143,18 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #if !defined(OS_CFG_SSSP_STACK_END)
   #define AMIROOS_CFG_SSSP_STACK_END            false
-#else
+#else /* !defined(OS_CFG_SSSP_STACK_END) */
   #define AMIROOS_CFG_SSSP_STACK_END            OS_CFG_SSSP_STACK_END
-#endif
+#endif /* !defined(OS_CFG_SSSP_STACK_END) */
 
 /**
  * @brief   Delay time (in microseconds) how long a SSSP signal must be active.
  */
 #if !defined(OS_CFG_SSSP_SIGNALDELAY)
   #define AMIROOS_CFG_SSSP_SIGNALDELAY          1000
-#else
+#else /* !defined(OS_CFG_SSSP_SIGNALDELAY) */
   #define AMIROOS_CFG_SSSP_SIGNALDELAY          OS_CFG_SSSP_SIGNALDELAY
-#endif
+#endif /* !defined(OS_CFG_SSSP_SIGNALDELAY) */
 
 /**
  * @brief   Time boundary for robot wide clock synchronization in microseconds.
@@ -163,9 +163,9 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #if !defined(OS_CFG_SSSP_SYSSYNCPERIOD)
   #define AMIROOS_CFG_SSSP_SYSSYNCPERIOD        1000000
-#else
+#else /* !defined(OS_CFG_SSSP_SYSSYNCPERIOD) */
   #define AMIROOS_CFG_SSSP_SYSSYNCPERIOD        OS_CFG_SSSP_SYSSYNCPERIOD
-#endif
+#endif /* !defined(OS_CFG_SSSP_SYSSYNCPERIOD) */
 
 /** @} */
 
@@ -181,18 +181,18 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #if !defined(OS_CFG_SHELL_ENABLE)
   #define AMIROOS_CFG_SHELL_ENABLE              true
-#else
+#else /* !defined(OS_CFG_SHELL_ENABLE) */
   #define AMIROOS_CFG_SHELL_ENABLE              OS_CFG_SHELL_ENABLE
-#endif
+#endif /* !defined(OS_CFG_SHELL_ENABLE) */
 
 /**
  * @brief   Shell thread stack size.
  */
 #if !defined(OS_CFG_SHELL_STACKSIZE)
   #define AMIROOS_CFG_SHELL_STACKSIZE           1024
-#else
+#else /* !defined(OS_CFG_SHELL_STACKSIZE) */
   #define AMIROOS_CFG_SHELL_STACKSIZE           OS_CFG_SHELL_STACKSIZE
-#endif
+#endif /* !defined(OS_CFG_SHELL_STACKSIZE) */
 
 /**
  * @brief   Shell thread priority.
@@ -213,27 +213,27 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #if !defined(OS_CFG_SHELL_THREADPRIO)
   #define AMIROOS_CFG_SHELL_THREADPRIO          AOS_THD_NORMALPRIO_MIN
-#else
+#else /* !defined(OS_CFG_SHELL_THREADPRIO) */
   #define AMIROOS_CFG_SHELL_THREADPRIO          OS_CFG_SHELL_THREADPRIO
-#endif
+#endif /* !defined(OS_CFG_SHELL_THREADPRIO) */
 
 /**
  * @brief   Shell maximum input line length.
  */
 #if !defined(OS_CFG_SHELL_LINEWIDTH)
   #define AMIROOS_CFG_SHELL_LINEWIDTH           64
-#else
+#else /* !defined(OS_CFG_SHELL_LINEWIDTH) */
   #define AMIROOS_CFG_SHELL_LINEWIDTH           OS_CFG_SHELL_LINEWIDTH
-#endif
+#endif /* !defined(OS_CFG_SHELL_LINEWIDTH) */
 
 /**
  * @brief   Shell maximum number of arguments.
  */
 #if !defined(OS_CFG_SHELL_MAXARGS)
   #define AMIROOS_CFG_SHELL_MAXARGS             4
-#else
+#else /* !defined(OS_CFG_SHELL_MAXARGS) */
   #define AMIROOS_CFG_SHELL_MAXARGS             OS_CFG_SHELL_MAXARGS
-#endif
+#endif /* !defined(OS_CFG_SHELL_MAXARGS) */
 
 /** @} */
 