commit 91bdafd48970a21e4dac64c3a2e0c215937e196c
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Fri Apr 26 11:16:05 2019 +0200

    Introduced optional CH_CFG_ST_TIMEDELTA definition per module.
    If no value is specified by the module, a conservative fallback of 1000µs is set.

diff --git a/modules/DiWheelDrive_1-1/chconf.h b/modules/DiWheelDrive_1-1/chconf.h
index b6a67cf..2148033 100644
--- a/modules/DiWheelDrive_1-1/chconf.h
+++ b/modules/DiWheelDrive_1-1/chconf.h
@@ -46,7 +46,19 @@
 #define CH_CFG_ST_RESOLUTION                    16
 #endif
 
-// more common definition in aos_chconf.h
+/**
+ * @brief   Time delta constant for the tick-less mode.
+ * @note    If this value is zero then the system uses the classic
+ *          periodic tick. This value represents the minimum number
+ *          of ticks that is safe to specify in a timeout directive.
+ *          The value one is not valid, timeouts are rounded up to
+ *          this value.
+ */
+#if !defined(CH_CFG_ST_TIMEDELTA)
+#define CH_CFG_ST_TIMEDELTA                     50
+#endif
+
+// more common definitions in aos_chconf.h
 
 /** @} */
 
diff --git a/modules/DiWheelDrive_1-2/chconf.h b/modules/DiWheelDrive_1-2/chconf.h
index e79f93f..43c649e 100644
--- a/modules/DiWheelDrive_1-2/chconf.h
+++ b/modules/DiWheelDrive_1-2/chconf.h
@@ -46,7 +46,19 @@
 #define CH_CFG_ST_RESOLUTION                    16
 #endif
 
-// more common definition in aos_chconf.h
+/**
+ * @brief   Time delta constant for the tick-less mode.
+ * @note    If this value is zero then the system uses the classic
+ *          periodic tick. This value represents the minimum number
+ *          of ticks that is safe to specify in a timeout directive.
+ *          The value one is not valid, timeouts are rounded up to
+ *          this value.
+ */
+#if !defined(CH_CFG_ST_TIMEDELTA)
+#define CH_CFG_ST_TIMEDELTA                     50
+#endif
+
+// more common definitions in aos_chconf.h
 
 /** @} */
 
diff --git a/modules/LightRing_1-0/chconf.h b/modules/LightRing_1-0/chconf.h
index 4cff710..52385a8 100644
--- a/modules/LightRing_1-0/chconf.h
+++ b/modules/LightRing_1-0/chconf.h
@@ -46,7 +46,19 @@
 #define CH_CFG_ST_RESOLUTION                    16
 #endif
 
-// more common definition in aos_chconf.h
+/**
+ * @brief   Time delta constant for the tick-less mode.
+ * @note    If this value is zero then the system uses the classic
+ *          periodic tick. This value represents the minimum number
+ *          of ticks that is safe to specify in a timeout directive.
+ *          The value one is not valid, timeouts are rounded up to
+ *          this value.
+ */
+#if !defined(CH_CFG_ST_TIMEDELTA)
+#define CH_CFG_ST_TIMEDELTA                     50
+#endif
+
+// more common definitions in aos_chconf.h
 
 /** @} */
 
diff --git a/modules/LightRing_1-2/chconf.h b/modules/LightRing_1-2/chconf.h
index 96cd202..07588f2 100644
--- a/modules/LightRing_1-2/chconf.h
+++ b/modules/LightRing_1-2/chconf.h
@@ -46,7 +46,19 @@
 #define CH_CFG_ST_RESOLUTION                    16
 #endif
 
-// more common definition in aos_chconf.h
+/**
+ * @brief   Time delta constant for the tick-less mode.
+ * @note    If this value is zero then the system uses the classic
+ *          periodic tick. This value represents the minimum number
+ *          of ticks that is safe to specify in a timeout directive.
+ *          The value one is not valid, timeouts are rounded up to
+ *          this value.
+ */
+#if !defined(CH_CFG_ST_TIMEDELTA)
+#define CH_CFG_ST_TIMEDELTA                     50
+#endif
+
+// more common definitions in aos_chconf.h
 
 /** @} */
 
diff --git a/modules/NUCLEO-F103RB/chconf.h b/modules/NUCLEO-F103RB/chconf.h
index dec49ac..867aaaa 100644
--- a/modules/NUCLEO-F103RB/chconf.h
+++ b/modules/NUCLEO-F103RB/chconf.h
@@ -46,7 +46,7 @@
 #define CH_CFG_ST_RESOLUTION                    16
 #endif
 
-// more common definition in aos_chconf.h
+// more common definitions in aos_chconf.h
 
 /** @} */
 
diff --git a/modules/NUCLEO-F401RE/chconf.h b/modules/NUCLEO-F401RE/chconf.h
index 123c767..81d33eb 100644
--- a/modules/NUCLEO-F401RE/chconf.h
+++ b/modules/NUCLEO-F401RE/chconf.h
@@ -46,7 +46,7 @@
 #define CH_CFG_ST_RESOLUTION                    32
 #endif
 
-// more common definition in aos_chconf.h
+// more common definitions in aos_chconf.h
 
 /** @} */
 
diff --git a/modules/NUCLEO-F767ZI/chconf.h b/modules/NUCLEO-F767ZI/chconf.h
index c6d6fed..f25cb04 100644
--- a/modules/NUCLEO-F767ZI/chconf.h
+++ b/modules/NUCLEO-F767ZI/chconf.h
@@ -46,7 +46,7 @@
 #define CH_CFG_ST_RESOLUTION                    32
 #endif
 
-// more common definition in aos_chconf.h
+// more common definitions in aos_chconf.h
 
 /** @} */
 
diff --git a/modules/NUCLEO-L476RG/chconf.h b/modules/NUCLEO-L476RG/chconf.h
index 71ecd7a..6565a2d 100644
--- a/modules/NUCLEO-L476RG/chconf.h
+++ b/modules/NUCLEO-L476RG/chconf.h
@@ -46,7 +46,7 @@
 #define CH_CFG_ST_RESOLUTION                    32
 #endif
 
-// more common definition in aos_chconf.h
+// more common definitions in aos_chconf.h
 
 /** @} */
 
diff --git a/modules/PowerManagement_1-1/chconf.h b/modules/PowerManagement_1-1/chconf.h
index 1eae532..378017a 100644
--- a/modules/PowerManagement_1-1/chconf.h
+++ b/modules/PowerManagement_1-1/chconf.h
@@ -46,7 +46,19 @@
 #define CH_CFG_ST_RESOLUTION                    32
 #endif
 
-// more common definition in aos_chconf.h
+/**
+ * @brief   Time delta constant for the tick-less mode.
+ * @note    If this value is zero then the system uses the classic
+ *          periodic tick. This value represents the minimum number
+ *          of ticks that is safe to specify in a timeout directive.
+ *          The value one is not valid, timeouts are rounded up to
+ *          this value.
+ */
+#if !defined(CH_CFG_ST_TIMEDELTA)
+#define CH_CFG_ST_TIMEDELTA                     20
+#endif
+
+// more common definitions in aos_chconf.h
 
 /** @} */
 
diff --git a/modules/PowerManagement_1-2/chconf.h b/modules/PowerManagement_1-2/chconf.h
index d601cd5..6cadd3f 100644
--- a/modules/PowerManagement_1-2/chconf.h
+++ b/modules/PowerManagement_1-2/chconf.h
@@ -46,7 +46,19 @@
 #define CH_CFG_ST_RESOLUTION                    32
 #endif
 
-// more common definition in aos_chconf.h
+/**
+ * @brief   Time delta constant for the tick-less mode.
+ * @note    If this value is zero then the system uses the classic
+ *          periodic tick. This value represents the minimum number
+ *          of ticks that is safe to specify in a timeout directive.
+ *          The value one is not valid, timeouts are rounded up to
+ *          this value.
+ */
+#if !defined(CH_CFG_ST_TIMEDELTA)
+#define CH_CFG_ST_TIMEDELTA                     20
+#endif
+
+// more common definitions in aos_chconf.h
 
 /** @} */
 
diff --git a/modules/STM32F407G-DISC1/chconf.h b/modules/STM32F407G-DISC1/chconf.h
index 1dfce21..a47d303 100644
--- a/modules/STM32F407G-DISC1/chconf.h
+++ b/modules/STM32F407G-DISC1/chconf.h
@@ -46,7 +46,7 @@
 #define CH_CFG_ST_RESOLUTION                    32
 #endif
 
-// more common definition in aos_chconf.h
+// more common definitions in aos_chconf.h
 
 /** @} */
 
diff --git a/modules/aos_chconf.h b/modules/aos_chconf.h
index 055f2d4..229750a 100644
--- a/modules/aos_chconf.h
+++ b/modules/aos_chconf.h
@@ -73,7 +73,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *          this value.
  */
 #if !defined(CH_CFG_ST_TIMEDELTA)
-#define CH_CFG_ST_TIMEDELTA                 50
+#define CH_CFG_ST_TIMEDELTA                 1000
 #endif
 
 /** @} */
diff --git a/tools/ide/QtCreator/QtCreatorSetup.sh b/tools/ide/QtCreator/QtCreatorSetup.sh
index f22cb67..74a97de 100755
--- a/tools/ide/QtCreator/QtCreatorSetup.sh
+++ b/tools/ide/QtCreator/QtCreatorSetup.sh
@@ -882,15 +882,15 @@ function deleteProjects {
   # list all files to be deleted
   if [ -z "$modulename" ]; then
     if [ $wipe != true ]; then
-      files=$(find "${projectdir}" -maxdepth 1 -type f | grep -E "^.+\.(includes|files|config|creator)$")
+      files=$(find "${projectdir}" -maxdepth 1 -type f | grep -E "^.+\.(includes|files|config|creator|cflags|cxxflags)$")
     else
-      files=$(find "${projectdir}" -maxdepth 1 -type f | grep -E "^.+\.(includes|files|config|creator|creator\.user)$")
+      files=$(find "${projectdir}" -maxdepth 1 -type f | grep -E "^.+\.(includes|files|config|creator|cflags|cxxflags|creator(\.user(\..+)?)?)$")
     fi
   else
     if [ $wipe != true ]; then
-      files=$(find "${projectdir}" -maxdepth 1 -type f | grep -E "^.${modulename}\.(includes|files|config|creator)$")
+      files=$(find "${projectdir}" -maxdepth 1 -type f | grep -E "^.${modulename}\.(includes|files|config|creator|cflags|cxxflags)$")
     else
-      files=$(find "${projectdir}" -maxdepth 1 -type f | grep -E "^.${modulename}\.(includes|files|config|creator|creator\.user)$")
+      files=$(find "${projectdir}" -maxdepth 1 -type f | grep -E "^.${modulename}\.(includes|files|config|creator|cflags|cxxflags|creator(\.user(\..+)?)?)$")
     fi
   fi
   if [ ! -z "$files" ]; then